--- stm32l4xx_hal_uart.c.original	2023-02-20 14:09:56.101438000 +0100
+++ stm32l4xx_hal_uart.c	2023-02-20 14:55:36.071839000 +0100
@@ -1124,6 +1124,10 @@
   * @{
   */
 
+// Defined in libs/lbm/smtc_hal/STMicroelectronics/STM32L4xx/src/smtc_hal_uart.c.
+extern UART_HandleTypeDef *printf_uart_handle;
+extern IRQn_Type printf_uart_irqn;
+
 /**
   * @brief Send an amount of data in blocking mode.
   * @note   When UART parity is not enabled (PCE = 0), and Word Length is configured to 9 bits (M1-M0 = 01),
@@ -1153,6 +1157,12 @@
       return  HAL_ERROR;
     }
 
+    // If log UART, then disable UART interruptions during the huart
+    // locking, so that if a byte is received while the locking, RX interrupts
+    // are not disabled for ever.
+    if (huart == printf_uart_handle) {
+      HAL_NVIC_DisableIRQ(printf_uart_irqn);
+    }
     __HAL_LOCK(huart);
 
     huart->ErrorCode = HAL_UART_ERROR_NONE;
@@ -1177,6 +1187,9 @@
     }
 
     __HAL_UNLOCK(huart);
+    if (huart == printf_uart_handle) {
+      HAL_NVIC_EnableIRQ(printf_uart_irqn);
+    }
 
     while (huart->TxXferCount > 0U)
     {
